{ *************************************************************************** }
{                                                                             }
{ WindowsXP-like Format Utility                                              }
{                                                                             }
{ Copyright (c) 2004 Sergey Mishin <mishinmail@mail.ru>                       }
{                                                                             }
{ This program is free software; you can redistribute it and/or               }
{ modify it under the terms of the GNU General Public                         }
{ License as published by the Free Software Foundation; either                }
{ version 2 of the License, or (at your option) any later version.            }
{                                                                             }
{ This program is distributed in the hope that it will be useful,             }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of              }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           }
{ General Public License for more details.                                    }
{                                                                             }
{ You should have received a copy of the GNU General Public License           }
{ along with this program; see the file COPYING.  If not, write to            }
{ the Free Software Foundation, Inc., 59 Temple Place - Suite 330,            }
{ Boston, MA 02111-1307, USA.                                                 }
{                                                                             }
{ *************************************************************************** }
unit uFormat;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QComCtrls, uXPAPI, uXPAPI_imp;

type
  TFormatForm = class(TForm)
    Label1: TLabel;
    cboDevice: TComboBox;
    Label2: TLabel;
    cboFileSystem: TComboBox;
    Label3: TLabel;
    cboClusterSize: TComboBox;
    lblLabel: TLabel;
    edtLabel: TEdit;
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    chkVerify: TCheckBox;
    ProgressBar1: TProgressBar;
    chkBootable: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure cboFileSystemChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormatForm: TFormatForm;

implementation

{$R *.xfm}

procedure TFormatForm.FormCreate(Sender: TObject);
begin
    font.assign(application.font);
    font.name:='';
    parentfont:=true;
    XPAPI.setdefaultcursor;

    //Thats enough so far ...
    if paramstr(1)<>'' then begin
       cboDevice.Items.Add(paramstr(1));
    end
    else begin
        cboDevice.Items.Add('/dev/fd0');
    end;
    cboDevice.ItemIndex:=0;


    //How many file system types do we load?
    //And what about Items.Add('minix');
    //               Items.Add('xiafs'); ?
    

    with cboFileSystem do
    begin
        Items.Add('MS DOS');
        Items.Add('ext2fs');
    end;




end;

procedure TFormatForm.Button2Click(Sender: TObject);
begin
     Close;
end;

procedure TFormatForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Action:=caFree;
end;

procedure TFormatForm.Button1Click(Sender: TObject);
var s: string;
    i: integer;
begin
     if MessageDlg('All data will be lost! Proceed anyway?',
        mtConfirmation,[mbYes,mbNo],0,mbNo) = mrYes then begin
         i:=cboFileSystem.ItemIndex;
          case i of
            0: begin  //ext2fs format
                   s:='mkfs.msdos '+cboDevice.Text;
            end;
            1: begin //dos format
               s:='mkfs.ext2 '+cboDevice.Text;
            end;
          end;
          XPAPI.ShellExecute(s,false);
     end;
end;

procedure TFormatForm.cboFileSystemChange(Sender: TObject);
var i: integer;
begin
    cboClusterSize.Clear;
    i:=cboFileSystem.ItemIndex;
    case i of
      0: begin
             cboClusterSize.Items.Add('Standard');
             chkVerify.Enabled:=False;
             chkBootable.Enabled:=False;
             lblLabel.Enabled:=False;
             edtLabel.Enabled:=False;
      end;
      1: begin
             cboClusterSize.Items.Add('1024');
             cboClusterSize.Items.Add('2048');
             cboClusterSize.Items.Add('4096');
             chkVerify.Enabled:=True;
             chkBootable.Enabled:=False;
             lblLabel.Enabled:=True;
             edtLabel.Enabled:=True;

      end;
    end;
    cboClusterSize.ItemIndex:=0;

end;

procedure TFormatForm.FormShow(Sender: TObject);
begin
    cboFileSystem.ItemIndex:=0;
    cboFileSystemChange(Self);
end;

end.
