{ *************************************************************************** }
{                                                                             }
{ WindowsXP-like Disk Format                                               }
{                                                                             }
{ Copyright (c) 2004 Sergey Mishin <mishinmail@mail.ru>                       }
{                                                                             }
{ This program is free software; you can redistribute it and/or               }
{ modify it under the terms of the GNU General Public                         }
{ License as published by the Free Software Foundation; either                }
{ version 2 of the License, or (at your option) any later version.            }
{                                                                             }
{ This program is distributed in the hope that it will be useful,             }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of              }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           }
{ General Public License for more details.                                    }
{                                                                             }
{ You should have received a copy of the GNU General Public License           }
{ along with this program; see the file COPYING.  If not, write to            }
{ the Free Software Foundation, Inc., 59 Temple Place - Suite 330,            }
{ Boston, MA 02111-1307, USA.                                                 }
{                                                                             }
{ *************************************************************************** }
unit umain;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QComCtrls, uXPAPI, uXPAPI_imp;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    cboDevice: TComboBox;
    Label2: TLabel;
    cboFileSystem: TComboBox;
    Label3: TLabel;
    cboClusterSize: TComboBox;
    Label4: TLabel;
    Edit1: TEdit;
    GroupBox1: TGroupBox;
    ProgressBar1: TProgressBar;
    Button1: TButton;
    Button2: TButton;
    chkQuickFormat: TCheckBox;
    chkVerify: TCheckBox;
    CheckBox3: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure cboFileSystemChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.xfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
    font.assign(application.font);
    font.name:='';
    parentfont:=true;
    XPAPI.setdefaultcursor;

    //How many file system types do we load?
    with cboFileSystem do
    begin
        Items.Add('MS DOS');
        Items.Add('ext2fs');
        ItemIndex:=0;
    end;

    //Thats enough so far ...
    with cboDevice do
    begin
        Items.Add('3" 1/2 Floppy');
        ItemIndex:=0;
    end;


end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     Close;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Action:=caFree;
end;

procedure TForm1.Button1Click(Sender: TObject);
var s1: string;
    s2: string;
    i: integer;
begin
     if MessageDlg('All data will be lost! Proceed anyway?',
        mtConfirmation,[mbYes,mbNo],0,mbNo) = mrYes then begin
         
          i:=cboFileSystem.ItemIndex;
          case i of
            0: begin  //ext2fs format
                 {if chkQuickFormat.Checked then s1:=
                 else s1:=
                     XPAPI.ShellExecute('umount /mnt/fd0',false);
                     XPAPI.ShellExecute('mke2fs /dev/fd0',false);
                     XPAPI.ShellExecute('mount /mnt/fd0',false);
                 end;}
            end;
            1: begin //dos format
                   XPAPI.ShellExecute('umount /mnt/fd0',false);
                   XPAPI.ShellExecute('mkdosfs /dev/fd0',false);
                   XPAPI.ShellExecute('mount /mnt/fd0',false);
            end;
          end;
     end;
end;

procedure TForm1.cboFileSystemChange(Sender: TObject);
var i: integer;
begin
    cboClusterSize.Clear;
    i:=cboFileSystem.ItemIndex;
    case i of
      0: begin
             cboClusterSize.Items.Add('Standard');
      end;
      1: begin
             cboClusterSize.Items.Add('1024');
             cboClusterSize.Items.Add('2048');
             cboClusterSize.Items.Add('4096');
      end;
    end;

end;

procedure TForm1.FormShow(Sender: TObject);
begin
    cboClusterSize.ItemIndex:=0;
end;

end.
